// $ANTLR 3.3 Nov 30, 2010 12:46:29 org/siddhi/compiler/SiddhiGrammarWalker.g 2012-01-13 10:20:16

    package org.siddhi.compiler;

    import org.siddhi.api.OutputDefinition;
    import org.siddhi.api.QueryFactory;
    import org.siddhi.api.condition.Condition;
    import org.siddhi.api.condition.ExpirableCondition;
    import org.siddhi.api.condition.pattern.EveryCondition;
    import org.siddhi.api.condition.pattern.FollowedByCondition;
    import org.siddhi.api.condition.sequence.SequenceCondition;
    import org.siddhi.api.condition.sequence.SequenceStarCondition;
    import org.siddhi.api.condition.where.ConditionOperator;
    import org.siddhi.api.condition.where.WhereCondition;
    import org.siddhi.api.eventstream.EventStream;
    import org.siddhi.api.eventstream.InputAbstractEventStream;
    import org.siddhi.api.eventstream.query.Query;
    import org.siddhi.api.eventstream.query.inputstream.QueryInputStream;
    import org.siddhi.api.eventstream.query.inputstream.property.StandardView;
    import org.siddhi.api.eventstream.query.inputstream.property.WindowType;
    import org.siddhi.api.exception.SiddhiCompilationException;

    import java.util.Date;
    import java.util.LinkedList;



import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
public class SiddhiGrammarWalker extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "DEFAULT_OUTPUT", "NEW_STREAM", "STREAM_PROP", "COND_DEF", "COND", "NAME", "NUM", "STRING", "COMMENT", "WS", "';'", "':='", "'['", "']'", "','", "'select'", "'*'", "'='", "'('", "')'", "'from'", "'win'", "'.'", "'time'", "'batch'", "'length'", "'std'", "'pattern'", "'sequence'", "'where'", "'having'", "'group by'", "'every'", "'->'", "'!'", "'$'", "'within'", "'or'", "'and'", "'%'", "'/'", "'-'", "'+'", "'this'", "'prev'", "'not'", "'last'", "'avg'", "'sum'", "'max'", "'min'", "'count'", "'true'", "'false'", "'string'", "'int'", "'long'", "'float'", "'double'", "'bool'", "'date'", "'firstUnique'", "'unique'", "'=='", "'!='", "'<'", "'>'", "'<='", "'>='", "'contains'", "MATH"
    };
    public static final int EOF=-1;
    public static final int T__14=14;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__19=19;
    public static final int T__20=20;
    public static final int T__21=21;
    public static final int T__22=22;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int T__29=29;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int T__33=33;
    public static final int T__34=34;
    public static final int T__35=35;
    public static final int T__36=36;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int T__40=40;
    public static final int T__41=41;
    public static final int T__42=42;
    public static final int T__43=43;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int T__50=50;
    public static final int T__51=51;
    public static final int T__52=52;
    public static final int T__53=53;
    public static final int T__54=54;
    public static final int T__55=55;
    public static final int T__56=56;
    public static final int T__57=57;
    public static final int T__58=58;
    public static final int T__59=59;
    public static final int T__60=60;
    public static final int T__61=61;
    public static final int T__62=62;
    public static final int T__63=63;
    public static final int T__64=64;
    public static final int T__65=65;
    public static final int T__66=66;
    public static final int T__67=67;
    public static final int T__68=68;
    public static final int T__69=69;
    public static final int T__70=70;
    public static final int T__71=71;
    public static final int T__72=72;
    public static final int T__73=73;
    public static final int DEFAULT_OUTPUT=4;
    public static final int NEW_STREAM=5;
    public static final int STREAM_PROP=6;
    public static final int COND_DEF=7;
    public static final int COND=8;
    public static final int NAME=9;
    public static final int NUM=10;
    public static final int STRING=11;
    public static final int COMMENT=12;
    public static final int WS=13;
    public static final int MATH=74;

    // delegates
    // delegators


        public SiddhiGrammarWalker(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public SiddhiGrammarWalker(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return SiddhiGrammarWalker.tokenNames; }
    public String getGrammarFileName() { return "org/siddhi/compiler/SiddhiGrammarWalker.g"; }


        QueryFactory qf =  QueryFactory.getInstance();
        List<EventStream> streamList =new ArrayList<EventStream>();
        int streamNameIndex=0;
        boolean inHaving=false;

        private String getNewStreamName() {
            return "TempStream"+(streamNameIndex++);
        }

        public String getErrorMessage(RecognitionException e,
                                          String[] tokenNames)
            {
                List stack = getRuleInvocationStack(e, this.getClass().getName());
                String msg = null;
                String inputContext =
                    input.LT(-3) == null ? "" : ((Tree)input.LT(-3)).getText()+" "+
                    input.LT(-2) == null ? "" : ((Tree)input.LT(-2)).getText()+" "+
                    input.LT(-1) == null ? "" : ((Tree)input.LT(-1)).getText()+" >>>"+
                    ((Tree)input.LT(1)).getText()+"<<< "+
                    ((Tree)input.LT(2)).getText()+" "+
                    ((Tree)input.LT(3)).getText();
                if ( e instanceof NoViableAltException ) {
                   NoViableAltException nvae = (NoViableAltException)e;
                   msg = " no viable alt; token="+e.token+
                      " (decision="+nvae.decisionNumber+
                      " state "+nvae.stateNumber+")"+
                      " decision=<<"+nvae.grammarDecisionDescription+">>";
                }
                else {
                   msg = super.getErrorMessage(e, tokenNames);
                }
                msg= stack+" "+msg+" context=..."+inputContext+"...";

                throw new SiddhiCompilationException(msg);
            }
           public String getTokenErrorDisplay(Token t) {
                return t.toString();
            }



    // $ANTLR start "siddhiGrammar"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:76:1: siddhiGrammar[List<EventStream> inputEventStreamList ] returns [List<EventStream> eventStreamList ] : ( stream )+ ;
    public final List<EventStream> siddhiGrammar(List<EventStream> inputEventStreamList) throws RecognitionException {
        List<EventStream> eventStreamList = null;


                if(inputEventStreamList!=null){
                    streamList = inputEventStreamList;
                }
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:85:2: ( ( stream )+ )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:85:4: ( stream )+
            {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:85:4: ( stream )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                switch ( input.LA(1) ) {
                case NAME:
                    {
                    alt1=1;
                    }
                    break;

                }

                switch (alt1) {
            	case 1 :
            	    // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: stream
            	    {
            	    pushFollow(FOLLOW_stream_in_siddhiGrammar80);
            	    stream();

            	    state._fsp--;
            	    if (state.failed) return eventStreamList;

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
            	    if (state.backtracking>0) {state.failed=true; return eventStreamList;}
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);


            }

            if ( state.backtracking==0 ) {

                      eventStreamList =streamList;
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return eventStreamList;
    }
    // $ANTLR end "siddhiGrammar"

    protected static class stream_scope {
        String name;
    }
    protected Stack stream_stack = new Stack();


    // $ANTLR start "stream"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:87:1: stream : ^(s= stmName streamType ) ;
    public final void stream() throws RecognitionException {
        stream_stack.push(new stream_scope());
        String s = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:91:5: ( ^(s= stmName streamType ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:91:7: ^(s= stmName streamType )
            {
            pushFollow(FOLLOW_stmName_in_stream105);
            s=stmName();

            state._fsp--;
            if (state.failed) return ;

            if ( state.backtracking==0 ) {
              ((stream_scope)stream_stack.peek()).name =s;
            }

            match(input, Token.DOWN, null); if (state.failed) return ;
            pushFollow(FOLLOW_streamType_in_stream109);
            streamType();

            state._fsp--;
            if (state.failed) return ;

            match(input, Token.UP, null); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            stream_stack.pop();
        }
        return ;
    }
    // $ANTLR end "stream"


    // $ANTLR start "streamType"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:93:1: streamType : ( inputStm[$stream::name] | queryStm[$stream::name] );
    public final void streamType() throws RecognitionException {
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:94:5: ( inputStm[$stream::name] | queryStm[$stream::name] )
            int alt2=2;
            switch ( input.LA(1) ) {
            case NAME:
                {
                alt2=1;
                }
                break;
            case 24:
                {
                alt2=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:94:7: inputStm[$stream::name]
                    {
                    pushFollow(FOLLOW_inputStm_in_streamType124);
                    inputStm(((stream_scope)stream_stack.peek()).name);

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:95:4: queryStm[$stream::name]
                    {
                    pushFollow(FOLLOW_queryStm_in_streamType130);
                    queryStm(((stream_scope)stream_stack.peek()).name);

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "streamType"


    // $ANTLR start "inputStm"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:98:1: inputStm[String name] : ( ^( NAME c= type ) )+ ;
    public final void inputStm(String name) throws RecognitionException {
        CommonTree NAME1=null;
        Class c = null;



                List<String> nameList =new ArrayList<String>();
                List<Class> classList =new ArrayList<Class>();
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:112:5: ( ( ^( NAME c= type ) )+ )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:112:7: ( ^( NAME c= type ) )+
            {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:112:7: ( ^( NAME c= type ) )+
            int cnt3=0;
            loop3:
            do {
                int alt3=2;
                switch ( input.LA(1) ) {
                case NAME:
                    {
                    alt3=1;
                    }
                    break;

                }

                switch (alt3) {
            	case 1 :
            	    // org/siddhi/compiler/SiddhiGrammarWalker.g:112:8: ^( NAME c= type )
            	    {
            	    NAME1=(CommonTree)match(input,NAME,FOLLOW_NAME_in_inputStm165); if (state.failed) return ;

            	    match(input, Token.DOWN, null); if (state.failed) return ;
            	    pushFollow(FOLLOW_type_in_inputStm169);
            	    c=type();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    match(input, Token.UP, null); if (state.failed) return ;
            	    if ( state.backtracking==0 ) {
            	      nameList.add((NAME1!=null?NAME1.getText():null)); classList.add(c);
            	    }

            	    }
            	    break;

            	default :
            	    if ( cnt3 >= 1 ) break loop3;
            	    if (state.backtracking>0) {state.failed=true; return ;}
                        EarlyExitException eee =
                            new EarlyExitException(3, input);
                        throw eee;
                }
                cnt3++;
            } while (true);


            }

            if ( state.backtracking==0 ) {

                      String[] nameArray=new String[nameList.size()];
                      Class[] classArray=new Class[classList.size()];
                      streamList.add(new InputAbstractEventStream(
                          name,
                          nameList.toArray(nameArray),
                          classList.toArray(classArray)
                      ));
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "inputStm"

    protected static class queryStm_scope {
        OutputDefinition outputDef;
        List<QueryInputStream> inputStreamList;
        WhereCondition whereCond;
        FollowedByCondition patternCond;
        SequenceCondition SequenceCond;
        Condition havingCond;
        String gpByCond;
        Map<String,Condition> condDefMap;
        Map<String,String> condOrder;
        String streamName;
        int condOrderNum;
    }
    protected Stack queryStm_stack = new Stack();


    // $ANTLR start "queryStm"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:115:1: queryStm[String name] returns [Query query] : queryInput ( queryCond )? ( queryOutput )? ;
    public final Query queryStm(String name) throws RecognitionException {
        queryStm_stack.push(new queryStm_scope());
        Query query = null;


                ((queryStm_scope)queryStm_stack.peek()).inputStreamList =new LinkedList<QueryInputStream>();
                ((queryStm_scope)queryStm_stack.peek()).condOrder =new HashMap<String,String>();
                ((queryStm_scope)queryStm_stack.peek()).condOrderNum =-1;;
                ((queryStm_scope)queryStm_stack.peek()).condDefMap =new HashMap<String,Condition>();
                List outputList = new LinkedList<String>();
                outputList.add("*");
                ((queryStm_scope)queryStm_stack.peek()).outputDef =new OutputDefinition(outputList);
                if(name==null){
                    name=getNewStreamName();
                }
                ((queryStm_scope)queryStm_stack.peek()).streamName =name;
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:167:5: ( queryInput ( queryCond )? ( queryOutput )? )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:167:7: queryInput ( queryCond )? ( queryOutput )?
            {
            pushFollow(FOLLOW_queryInput_in_queryStm217);
            queryInput();

            state._fsp--;
            if (state.failed) return query;
            // org/siddhi/compiler/SiddhiGrammarWalker.g:167:18: ( queryCond )?
            int alt4=2;
            switch ( input.LA(1) ) {
                case COND:
                case 31:
                case 32:
                    {
                    alt4=1;
                    }
                    break;
            }

            switch (alt4) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: queryCond
                    {
                    pushFollow(FOLLOW_queryCond_in_queryStm219);
                    queryCond();

                    state._fsp--;
                    if (state.failed) return query;

                    }
                    break;

            }

            // org/siddhi/compiler/SiddhiGrammarWalker.g:167:29: ( queryOutput )?
            int alt5=2;
            switch ( input.LA(1) ) {
                case 19:
                    {
                    alt5=1;
                    }
                    break;
            }

            switch (alt5) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: queryOutput
                    {
                    pushFollow(FOLLOW_queryOutput_in_queryStm222);
                    queryOutput();

                    state._fsp--;
                    if (state.failed) return query;

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

                      if(((queryStm_scope)queryStm_stack.peek()).patternCond!=null){
                          query = qf.createQuery( name,((queryStm_scope)queryStm_stack.peek()).outputDef, ((queryStm_scope)queryStm_stack.peek()).inputStreamList,((queryStm_scope)queryStm_stack.peek()).patternCond);
                      } else if(((queryStm_scope)queryStm_stack.peek()).SequenceCond!=null){
                          query = qf.createQuery( name,((queryStm_scope)queryStm_stack.peek()).outputDef, ((queryStm_scope)queryStm_stack.peek()).inputStreamList,((queryStm_scope)queryStm_stack.peek()).SequenceCond);
                      } else if(((queryStm_scope)queryStm_stack.peek()).inputStreamList.size()==2 &&((queryStm_scope)queryStm_stack.peek()).whereCond!=null){
                          query = qf.createQuery( name,
                                                   ((queryStm_scope)queryStm_stack.peek()).outputDef,
                                                   qf.innerJoin(((queryStm_scope)queryStm_stack.peek()).inputStreamList.get(0),((queryStm_scope)queryStm_stack.peek()).inputStreamList.get(1)),
                                                   ((queryStm_scope)queryStm_stack.peek()).whereCond);
                      } else if(((queryStm_scope)queryStm_stack.peek()).inputStreamList.size()==1 &&((queryStm_scope)queryStm_stack.peek()).whereCond!=null){
                           query = qf.createQuery( name, ((queryStm_scope)queryStm_stack.peek()).outputDef,((queryStm_scope)queryStm_stack.peek()).inputStreamList.get(0),((queryStm_scope)queryStm_stack.peek()).whereCond);

                           if(((queryStm_scope)queryStm_stack.peek()).gpByCond!=null){
                              query.groupBy(((queryStm_scope)queryStm_stack.peek()).gpByCond);
                           }
                           if(((queryStm_scope)queryStm_stack.peek()).havingCond!=null){
                              query.having(((queryStm_scope)queryStm_stack.peek()).havingCond);
                           }
                      }else{
                          throw new SiddhiCompilationException("Not fall under valid Query type: number of input streams="+((queryStm_scope)queryStm_stack.peek()).inputStreamList.size());
                      }
                      streamList.add(query);
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            queryStm_stack.pop();
        }
        return query;
    }
    // $ANTLR end "queryStm"


    // $ANTLR start "queryOutput"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:170:1: queryOutput : ( ^( 'select' '*' ) | ^( 'select' ( outputItem )+ ) );
    public final void queryOutput() throws RecognitionException {
        String outputItem2 = null;



                List outputList=new LinkedList<String>();
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:177:2: ( ^( 'select' '*' ) | ^( 'select' ( outputItem )+ ) )
            int alt7=2;
            switch ( input.LA(1) ) {
            case 19:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case 20:
                        {
                        alt7=1;
                        }
                        break;
                    case NAME:
                    case 39:
                        {
                        alt7=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return ;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 7, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:177:4: ^( 'select' '*' )
                    {
                    match(input,19,FOLLOW_19_in_queryOutput252); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    match(input,20,FOLLOW_20_in_queryOutput254); if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       outputList.add("*");
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:178:4: ^( 'select' ( outputItem )+ )
                    {
                    match(input,19,FOLLOW_19_in_queryOutput263); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:178:15: ( outputItem )+
                    int cnt6=0;
                    loop6:
                    do {
                        int alt6=2;
                        switch ( input.LA(1) ) {
                        case NAME:
                        case 39:
                            {
                            alt6=1;
                            }
                            break;

                        }

                        switch (alt6) {
                    	case 1 :
                    	    // org/siddhi/compiler/SiddhiGrammarWalker.g:178:17: outputItem
                    	    {
                    	    pushFollow(FOLLOW_outputItem_in_queryOutput267);
                    	    outputItem2=outputItem();

                    	    state._fsp--;
                    	    if (state.failed) return ;
                    	    if ( state.backtracking==0 ) {
                    	      outputList.add(outputItem2);
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt6 >= 1 ) break loop6;
                    	    if (state.backtracking>0) {state.failed=true; return ;}
                                EarlyExitException eee =
                                    new EarlyExitException(6, input);
                                throw eee;
                        }
                        cnt6++;
                    } while (true);


                    match(input, Token.UP, null); if (state.failed) return ;

                    }
                    break;

            }
            if ( state.backtracking==0 ) {

                      ((queryStm_scope)queryStm_stack.peek()).outputDef = new OutputDefinition(outputList);
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "queryOutput"


    // $ANTLR start "outputItem"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:180:1: outputItem returns [String value] : ( ^( NAME ( aggregate | defaultOut | outAttriName ) ) | outAttriName );
    public final String outputItem() throws RecognitionException {
        String value = null;

        CommonTree NAME3=null;
        String aggregate4 = null;

        String defaultOut5 = null;

        String outAttriName6 = null;

        String outAttriName7 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:181:5: ( ^( NAME ( aggregate | defaultOut | outAttriName ) ) | outAttriName )
            int alt9=2;
            switch ( input.LA(1) ) {
            case NAME:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case DEFAULT_OUTPUT:
                    case 39:
                    case 51:
                    case 52:
                    case 53:
                    case 54:
                    case 55:
                        {
                        alt9=1;
                        }
                        break;
                    case NAME:
                        {
                        switch ( input.LA(4) ) {
                        case UP:
                            {
                            int LA9_6 = input.LA(5);

                            if ( (synpred10_SiddhiGrammarWalker()) ) {
                                alt9=1;
                            }
                            else if ( (true) ) {
                                alt9=2;
                            }
                            else {
                                if (state.backtracking>0) {state.failed=true; return value;}
                                NoViableAltException nvae =
                                    new NoViableAltException("", 9, 6, input);

                                throw nvae;
                            }
                            }
                            break;
                        case DOWN:
                            {
                            alt9=1;
                            }
                            break;
                        default:
                            if (state.backtracking>0) {state.failed=true; return value;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 9, 5, input);

                            throw nvae;
                        }

                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return value;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 9, 3, input);

                        throw nvae;
                    }

                    }
                    break;
                case EOF:
                case UP:
                case NAME:
                case 39:
                    {
                    alt9=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return value;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 9, 1, input);

                    throw nvae;
                }

                }
                break;
            case 39:
                {
                alt9=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:181:6: ^( NAME ( aggregate | defaultOut | outAttriName ) )
                    {
                    NAME3=(CommonTree)match(input,NAME,FOLLOW_NAME_in_outputItem290); if (state.failed) return value;

                    if ( state.backtracking==0 ) {
                      value =(NAME3!=null?NAME3.getText():null)+"=";
                    }

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:182:9: ( aggregate | defaultOut | outAttriName )
                    int alt8=3;
                    switch ( input.LA(1) ) {
                    case 51:
                    case 52:
                    case 53:
                    case 54:
                    case 55:
                        {
                        alt8=1;
                        }
                        break;
                    case DEFAULT_OUTPUT:
                        {
                        alt8=2;
                        }
                        break;
                    case NAME:
                    case 39:
                        {
                        alt8=3;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return value;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 8, 0, input);

                        throw nvae;
                    }

                    switch (alt8) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:183:9: aggregate
                            {
                            pushFollow(FOLLOW_aggregate_in_outputItem313);
                            aggregate4=aggregate();

                            state._fsp--;
                            if (state.failed) return value;
                            if ( state.backtracking==0 ) {
                              value+=aggregate4;
                            }

                            }
                            break;
                        case 2 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:184:10: defaultOut
                            {
                            pushFollow(FOLLOW_defaultOut_in_outputItem326);
                            defaultOut5=defaultOut();

                            state._fsp--;
                            if (state.failed) return value;
                            if ( state.backtracking==0 ) {
                              value+=defaultOut5;
                            }

                            }
                            break;
                        case 3 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:185:10: outAttriName
                            {
                            pushFollow(FOLLOW_outAttriName_in_outputItem339);
                            outAttriName6=outAttriName();

                            state._fsp--;
                            if (state.failed) return value;
                            if ( state.backtracking==0 ) {
                              value+=outAttriName6;
                            }

                            }
                            break;

                    }


                    match(input, Token.UP, null); if (state.failed) return value;

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:188:3: outAttriName
                    {
                    pushFollow(FOLLOW_outAttriName_in_outputItem361);
                    outAttriName7=outAttriName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =outAttriName7;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "outputItem"


    // $ANTLR start "defaultOut"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:190:1: defaultOut returns [String value] : ^( DEFAULT_OUTPUT type val ) ;
    public final String defaultOut() throws RecognitionException {
        String value = null;

        Class type8 = null;

        String val9 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:191:5: ( ^( DEFAULT_OUTPUT type val ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:191:6: ^( DEFAULT_OUTPUT type val )
            {
            match(input,DEFAULT_OUTPUT,FOLLOW_DEFAULT_OUTPUT_in_defaultOut383); if (state.failed) return value;

            match(input, Token.DOWN, null); if (state.failed) return value;
            pushFollow(FOLLOW_type_in_defaultOut386);
            type8=type();

            state._fsp--;
            if (state.failed) return value;
            pushFollow(FOLLOW_val_in_defaultOut388);
            val9=val();

            state._fsp--;
            if (state.failed) return value;

            match(input, Token.UP, null); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value ="("+type8.getSimpleName()+")"+val9;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "defaultOut"


    // $ANTLR start "queryInput"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:195:1: queryInput : ^( 'from' ( queryInputStm )+ ) ;
    public final void queryInput() throws RecognitionException {
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:196:2: ( ^( 'from' ( queryInputStm )+ ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:196:4: ^( 'from' ( queryInputStm )+ )
            {
            match(input,24,FOLLOW_24_in_queryInput408); if (state.failed) return ;

            match(input, Token.DOWN, null); if (state.failed) return ;
            // org/siddhi/compiler/SiddhiGrammarWalker.g:196:13: ( queryInputStm )+
            int cnt10=0;
            loop10:
            do {
                int alt10=2;
                switch ( input.LA(1) ) {
                case NEW_STREAM:
                case NAME:
                    {
                    alt10=1;
                    }
                    break;

                }

                switch (alt10) {
            	case 1 :
            	    // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: queryInputStm
            	    {
            	    pushFollow(FOLLOW_queryInputStm_in_queryInput410);
            	    queryInputStm();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    if ( cnt10 >= 1 ) break loop10;
            	    if (state.backtracking>0) {state.failed=true; return ;}
                        EarlyExitException eee =
                            new EarlyExitException(10, input);
                        throw eee;
                }
                cnt10++;
            } while (true);


            match(input, Token.UP, null); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "queryInput"

    protected static class queryInputStm_scope {
        QueryInputStream stream;
    }
    protected Stack queryInputStm_stack = new Stack();


    // $ANTLR start "queryInputStm"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:198:1: queryInputStm : ( ^( NEW_STREAM queryStm[null] ( stmProp )? ) | ^( stmName ( stmProp )? ) );
    public final void queryInputStm() throws RecognitionException {
        queryInputStm_stack.push(new queryInputStm_scope());
        Query queryStm10 = null;

        String stmName11 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:205:2: ( ^( NEW_STREAM queryStm[null] ( stmProp )? ) | ^( stmName ( stmProp )? ) )
            int alt13=2;
            switch ( input.LA(1) ) {
            case NEW_STREAM:
                {
                alt13=1;
                }
                break;
            case NAME:
                {
                alt13=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;
            }

            switch (alt13) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:205:5: ^( NEW_STREAM queryStm[null] ( stmProp )? )
                    {
                    match(input,NEW_STREAM,FOLLOW_NEW_STREAM_in_queryInputStm439); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_queryStm_in_queryInputStm442);
                    queryStm10=queryStm(null);

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                        ((queryInputStm_scope)queryInputStm_stack.peek()).stream =qf.from(queryStm10); 
                    }
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:206:10: ( stmProp )?
                    int alt11=2;
                    switch ( input.LA(1) ) {
                        case STREAM_PROP:
                            {
                            alt11=1;
                            }
                            break;
                    }

                    switch (alt11) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: stmProp
                            {
                            pushFollow(FOLLOW_stmProp_in_queryInputStm458);
                            stmProp();

                            state._fsp--;
                            if (state.failed) return ;

                            }
                            break;

                    }


                    match(input, Token.UP, null); if (state.failed) return ;

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:207:5: ^( stmName ( stmProp )? )
                    {
                    pushFollow(FOLLOW_stmName_in_queryInputStm467);
                    stmName11=stmName();

                    state._fsp--;
                    if (state.failed) return ;

                    if ( state.backtracking==0 ) {

                                  for(EventStream eventStream :streamList){
                                      if(null!=eventStream&&eventStream.getStreamId().equals(stmName11)){
                                          ((queryInputStm_scope)queryInputStm_stack.peek()).stream =qf.from(eventStream);
                                          break;
                                      }
                                  }
                                  if(((queryInputStm_scope)queryInputStm_stack.peek()).stream==null){
                                      throw new SiddhiCompilationException(stmName11+" is not defined, assign the streams before using them");
                                  }
                              
                    }

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return ;
                        // org/siddhi/compiler/SiddhiGrammarWalker.g:219:9: ( stmProp )?
                        int alt12=2;
                        switch ( input.LA(1) ) {
                            case STREAM_PROP:
                                {
                                alt12=1;
                                }
                                break;
                        }

                        switch (alt12) {
                            case 1 :
                                // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: stmProp
                                {
                                pushFollow(FOLLOW_stmProp_in_queryInputStm484);
                                stmProp();

                                state._fsp--;
                                if (state.failed) return ;

                                }
                                break;

                        }


                        match(input, Token.UP, null); if (state.failed) return ;
                    }

                    }
                    break;

            }
            if ( state.backtracking==0 ) {

                    ((queryStm_scope)queryStm_stack.peek()).inputStreamList.add(((queryInputStm_scope)queryInputStm_stack.peek()).stream);
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            queryInputStm_stack.pop();
        }
        return ;
    }
    // $ANTLR end "queryInputStm"


    // $ANTLR start "stmProp"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:221:1: stmProp : ^( STREAM_PROP ( stmStd )? ( stmWin )? ) ;
    public final void stmProp() throws RecognitionException {
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:222:2: ( ^( STREAM_PROP ( stmStd )? ( stmWin )? ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:222:4: ^( STREAM_PROP ( stmStd )? ( stmWin )? )
            {
            match(input,STREAM_PROP,FOLLOW_STREAM_PROP_in_stmProp497); if (state.failed) return ;

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return ;
                // org/siddhi/compiler/SiddhiGrammarWalker.g:222:18: ( stmStd )?
                int alt14=2;
                switch ( input.LA(1) ) {
                    case 30:
                        {
                        alt14=1;
                        }
                        break;
                }

                switch (alt14) {
                    case 1 :
                        // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: stmStd
                        {
                        pushFollow(FOLLOW_stmStd_in_stmProp499);
                        stmStd();

                        state._fsp--;
                        if (state.failed) return ;

                        }
                        break;

                }

                // org/siddhi/compiler/SiddhiGrammarWalker.g:222:26: ( stmWin )?
                int alt15=2;
                switch ( input.LA(1) ) {
                    case 25:
                        {
                        alt15=1;
                        }
                        break;
                }

                switch (alt15) {
                    case 1 :
                        // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: stmWin
                        {
                        pushFollow(FOLLOW_stmWin_in_stmProp502);
                        stmWin();

                        state._fsp--;
                        if (state.failed) return ;

                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return ;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "stmProp"


    // $ANTLR start "stmWin"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:224:1: stmWin : ^( 'win' winType NUM ) ;
    public final void stmWin() throws RecognitionException {
        CommonTree NUM13=null;
        WindowType winType12 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:225:5: ( ^( 'win' winType NUM ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:225:7: ^( 'win' winType NUM )
            {
            match(input,25,FOLLOW_25_in_stmWin518); if (state.failed) return ;

            match(input, Token.DOWN, null); if (state.failed) return ;
            pushFollow(FOLLOW_winType_in_stmWin520);
            winType12=winType();

            state._fsp--;
            if (state.failed) return ;
            NUM13=(CommonTree)match(input,NUM,FOLLOW_NUM_in_stmWin522); if (state.failed) return ;

            match(input, Token.UP, null); if (state.failed) return ;
            if ( state.backtracking==0 ) {
              ((queryInputStm_scope)queryInputStm_stack.peek()).stream.setWindow(winType12,Integer.parseInt((NUM13!=null?NUM13.getText():null)));
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "stmWin"


    // $ANTLR start "stmStd"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:227:1: stmStd : ^( 'std' uniqueType attriName ) ;
    public final void stmStd() throws RecognitionException {
        StandardView uniqueType14 = null;

        String attriName15 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:228:2: ( ^( 'std' uniqueType attriName ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:228:4: ^( 'std' uniqueType attriName )
            {
            match(input,30,FOLLOW_30_in_stmStd541); if (state.failed) return ;

            match(input, Token.DOWN, null); if (state.failed) return ;
            pushFollow(FOLLOW_uniqueType_in_stmStd543);
            uniqueType14=uniqueType();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_attriName_in_stmStd545);
            attriName15=attriName();

            state._fsp--;
            if (state.failed) return ;

            match(input, Token.UP, null); if (state.failed) return ;
            if ( state.backtracking==0 ) {
              ((queryInputStm_scope)queryInputStm_stack.peek()).stream.setStandardView(uniqueType14,attriName15);
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "stmStd"


    // $ANTLR start "queryCond"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:231:1: queryCond : ( ^( COND ( whareCond )? ( gpByCond )? ( havingCond )? ) | ^( 'pattern' ^( COND_DEF condDefs ) ^( COND pattern[false] ) ) | ^( 'sequence' ^( COND_DEF condDefs ) ^( COND seq ) ) );
    public final void queryCond() throws RecognitionException {
        SiddhiGrammarWalker.pattern_return pattern16 = null;

        List<Condition> seq17 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:232:2: ( ^( COND ( whareCond )? ( gpByCond )? ( havingCond )? ) | ^( 'pattern' ^( COND_DEF condDefs ) ^( COND pattern[false] ) ) | ^( 'sequence' ^( COND_DEF condDefs ) ^( COND seq ) ) )
            int alt19=3;
            switch ( input.LA(1) ) {
            case COND:
                {
                alt19=1;
                }
                break;
            case 31:
                {
                alt19=2;
                }
                break;
            case 32:
                {
                alt19=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }

            switch (alt19) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:232:4: ^( COND ( whareCond )? ( gpByCond )? ( havingCond )? )
                    {
                    match(input,COND,FOLLOW_COND_in_queryCond562); if (state.failed) return ;

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return ;
                        // org/siddhi/compiler/SiddhiGrammarWalker.g:232:11: ( whareCond )?
                        int alt16=2;
                        switch ( input.LA(1) ) {
                            case 33:
                                {
                                alt16=1;
                                }
                                break;
                        }

                        switch (alt16) {
                            case 1 :
                                // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: whareCond
                                {
                                pushFollow(FOLLOW_whareCond_in_queryCond564);
                                whareCond();

                                state._fsp--;
                                if (state.failed) return ;

                                }
                                break;

                        }

                        // org/siddhi/compiler/SiddhiGrammarWalker.g:232:22: ( gpByCond )?
                        int alt17=2;
                        switch ( input.LA(1) ) {
                            case 35:
                                {
                                alt17=1;
                                }
                                break;
                        }

                        switch (alt17) {
                            case 1 :
                                // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: gpByCond
                                {
                                pushFollow(FOLLOW_gpByCond_in_queryCond567);
                                gpByCond();

                                state._fsp--;
                                if (state.failed) return ;

                                }
                                break;

                        }

                        // org/siddhi/compiler/SiddhiGrammarWalker.g:232:33: ( havingCond )?
                        int alt18=2;
                        switch ( input.LA(1) ) {
                            case 34:
                                {
                                alt18=1;
                                }
                                break;
                        }

                        switch (alt18) {
                            case 1 :
                                // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: havingCond
                                {
                                pushFollow(FOLLOW_havingCond_in_queryCond571);
                                havingCond();

                                state._fsp--;
                                if (state.failed) return ;

                                }
                                break;

                        }


                        match(input, Token.UP, null); if (state.failed) return ;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:233:4: ^( 'pattern' ^( COND_DEF condDefs ) ^( COND pattern[false] ) )
                    {
                    match(input,31,FOLLOW_31_in_queryCond579); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    match(input,COND_DEF,FOLLOW_COND_DEF_in_queryCond583); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_condDefs_in_queryCond585);
                    condDefs();

                    state._fsp--;
                    if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;
                    match(input,COND,FOLLOW_COND_in_queryCond590); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_pattern_in_queryCond592);
                    pattern16=pattern(false);

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                      ((queryStm_scope)queryStm_stack.peek()).patternCond =new FollowedByCondition((pattern16!=null?pattern16.condList:null));
                    }

                    match(input, Token.UP, null); if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:234:4: ^( 'sequence' ^( COND_DEF condDefs ) ^( COND seq ) )
                    {
                    match(input,32,FOLLOW_32_in_queryCond604); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    match(input,COND_DEF,FOLLOW_COND_DEF_in_queryCond607); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_condDefs_in_queryCond609);
                    condDefs();

                    state._fsp--;
                    if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;
                    match(input,COND,FOLLOW_COND_in_queryCond613); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_seq_in_queryCond615);
                    seq17=seq();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                      ((queryStm_scope)queryStm_stack.peek()).SequenceCond =new SequenceCondition(seq17);
                    }

                    match(input, Token.UP, null); if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "queryCond"


    // $ANTLR start "whareCond"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:236:1: whareCond : ^( 'where' cond ) ;
    public final void whareCond() throws RecognitionException {
        Condition cond18 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:237:2: ( ^( 'where' cond ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:237:3: ^( 'where' cond )
            {
            match(input,33,FOLLOW_33_in_whareCond629); if (state.failed) return ;

            match(input, Token.DOWN, null); if (state.failed) return ;
            pushFollow(FOLLOW_cond_in_whareCond631);
            cond18=cond();

            state._fsp--;
            if (state.failed) return ;

            match(input, Token.UP, null); if (state.failed) return ;
            if ( state.backtracking==0 ) {
              ((queryStm_scope)queryStm_stack.peek()).whereCond =(WhereCondition)cond18;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "whareCond"


    // $ANTLR start "havingCond"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:240:1: havingCond : ^( 'having' cond ) ;
    public final void havingCond() throws RecognitionException {
        Condition cond19 = null;


         inHaving=true; 
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:243:2: ( ^( 'having' cond ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:243:3: ^( 'having' cond )
            {
            match(input,34,FOLLOW_34_in_havingCond663); if (state.failed) return ;

            match(input, Token.DOWN, null); if (state.failed) return ;
            pushFollow(FOLLOW_cond_in_havingCond665);
            cond19=cond();

            state._fsp--;
            if (state.failed) return ;

            match(input, Token.UP, null); if (state.failed) return ;
            if ( state.backtracking==0 ) {
              ((queryStm_scope)queryStm_stack.peek()).havingCond =cond19;
            }

            }

            if ( state.backtracking==0 ) {
               inHaving=false; 
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "havingCond"


    // $ANTLR start "gpByCond"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:246:1: gpByCond : ( ^( 'group by' attriName ) | ^( 'group by' streamAttriName ) );
    public final void gpByCond() throws RecognitionException {
        String attriName20 = null;

        String streamAttriName21 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:247:2: ( ^( 'group by' attriName ) | ^( 'group by' streamAttriName ) )
            int alt20=2;
            switch ( input.LA(1) ) {
            case 35:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case NAME:
                        {
                        switch ( input.LA(4) ) {
                        case UP:
                            {
                            alt20=1;
                            }
                            break;
                        case DOWN:
                            {
                            alt20=2;
                            }
                            break;
                        default:
                            if (state.backtracking>0) {state.failed=true; return ;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 20, 3, input);

                            throw nvae;
                        }

                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return ;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 20, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 20, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }

            switch (alt20) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:247:3: ^( 'group by' attriName )
                    {
                    match(input,35,FOLLOW_35_in_gpByCond679); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_attriName_in_gpByCond681);
                    attriName20=attriName();

                    state._fsp--;
                    if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                      String stm=((queryStm_scope)queryStm_stack.peek()).inputStreamList.get(0).getEventStream().getStreamId();((queryStm_scope)queryStm_stack.peek()).gpByCond =stm+"."+attriName20;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:248:3: ^( 'group by' streamAttriName )
                    {
                    match(input,35,FOLLOW_35_in_gpByCond696); if (state.failed) return ;

                    match(input, Token.DOWN, null); if (state.failed) return ;
                    pushFollow(FOLLOW_streamAttriName_in_gpByCond698);
                    streamAttriName21=streamAttriName();

                    state._fsp--;
                    if (state.failed) return ;

                    match(input, Token.UP, null); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                      ((queryStm_scope)queryStm_stack.peek()).gpByCond =streamAttriName21;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "gpByCond"


    // $ANTLR start "condDefs"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:250:1: condDefs : ( condDef )+ ;
    public final void condDefs() throws RecognitionException {
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:251:2: ( ( condDef )+ )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:251:4: ( condDef )+
            {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:251:4: ( condDef )+
            int cnt21=0;
            loop21:
            do {
                int alt21=2;
                switch ( input.LA(1) ) {
                case NAME:
                    {
                    alt21=1;
                    }
                    break;

                }

                switch (alt21) {
            	case 1 :
            	    // org/siddhi/compiler/SiddhiGrammarWalker.g:0:0: condDef
            	    {
            	    pushFollow(FOLLOW_condDef_in_condDefs712);
            	    condDef();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    if ( cnt21 >= 1 ) break loop21;
            	    if (state.backtracking>0) {state.failed=true; return ;}
                        EarlyExitException eee =
                            new EarlyExitException(21, input);
                        throw eee;
                }
                cnt21++;
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "condDefs"


    // $ANTLR start "condDef"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:253:1: condDef : ^( NAME cond ) ;
    public final void condDef() throws RecognitionException {
        CommonTree NAME22=null;
        Condition cond23 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:254:4: ( ^( NAME cond ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:254:6: ^( NAME cond )
            {
            NAME22=(CommonTree)match(input,NAME,FOLLOW_NAME_in_condDef726); if (state.failed) return ;

            match(input, Token.DOWN, null); if (state.failed) return ;
            pushFollow(FOLLOW_cond_in_condDef728);
            cond23=cond();

            state._fsp--;
            if (state.failed) return ;

            match(input, Token.UP, null); if (state.failed) return ;
            if ( state.backtracking==0 ) {
              ((queryStm_scope)queryStm_stack.peek()).condDefMap.put((NAME22!=null?NAME22.getText():null),cond23);
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "condDef"

    protected static class pattern_scope {
        boolean afterNull;
    }
    protected Stack pattern_stack = new Stack();

    public static class pattern_return extends TreeRuleReturnScope {
        public List<Condition> condList;
        public boolean isAfterNullOut;
    };

    // $ANTLR start "pattern"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:276:1: pattern[boolean isAfterNullIn] returns [List<Condition> condList, boolean isAfterNullOut] : ( ^( 'every' nep= nonEveryPattern[$pattern::afterNull] ) (p= pattern[false] )? | nep= nonEveryPattern[$pattern::afterNull] (p= pattern[$pattern::afterNull] )? | ^( '!' pat= patternItem[$pattern::afterNull] ) (p= pattern[true] ) );
    public final SiddhiGrammarWalker.pattern_return pattern(boolean  isAfterNullIn) throws RecognitionException {
        pattern_stack.push(new pattern_scope());
        SiddhiGrammarWalker.pattern_return retval = new SiddhiGrammarWalker.pattern_return();
        retval.start = input.LT(1);

        SiddhiGrammarWalker.nonEveryPattern_return nep = null;

        SiddhiGrammarWalker.pattern_return p = null;

        Condition pat = null;



                 ((pattern_scope)pattern_stack.peek()).afterNull = isAfterNullIn;
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:286:5: ( ^( 'every' nep= nonEveryPattern[$pattern::afterNull] ) (p= pattern[false] )? | nep= nonEveryPattern[$pattern::afterNull] (p= pattern[$pattern::afterNull] )? | ^( '!' pat= patternItem[$pattern::afterNull] ) (p= pattern[true] ) )
            int alt24=3;
            switch ( input.LA(1) ) {
            case 36:
                {
                alt24=1;
                }
                break;
            case 38:
                {
                int LA24_2 = input.LA(2);

                if ( (synpred27_SiddhiGrammarWalker()) ) {
                    alt24=2;
                }
                else if ( (true) ) {
                    alt24=3;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 24, 2, input);

                    throw nvae;
                }
                }
                break;
            case NAME:
                {
                alt24=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:286:7: ^( 'every' nep= nonEveryPattern[$pattern::afterNull] ) (p= pattern[false] )?
                    {
                    match(input,36,FOLLOW_36_in_pattern796); if (state.failed) return retval;

                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    pushFollow(FOLLOW_nonEveryPattern_in_pattern800);
                    nep=nonEveryPattern(((pattern_scope)pattern_stack.peek()).afterNull);

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                      retval.condList =new LinkedList<Condition>(); retval.condList.add(new EveryCondition((nep!=null?nep.condList:null))); ((pattern_scope)pattern_stack.peek()).afterNull =(nep!=null?nep.isAfterNullOut:false);
                    }

                    match(input, Token.UP, null); if (state.failed) return retval;
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:287:8: (p= pattern[false] )?
                    int alt22=2;
                    switch ( input.LA(1) ) {
                        case NAME:
                        case 36:
                        case 38:
                            {
                            alt22=1;
                            }
                            break;
                    }

                    switch (alt22) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:287:10: p= pattern[false]
                            {
                            pushFollow(FOLLOW_pattern_in_pattern817);
                            p=pattern(false);

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                              retval.condList.addAll((p!=null?p.condList:null));((pattern_scope)pattern_stack.peek()).afterNull =(p!=null?p.isAfterNullOut:false);
                            }

                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:288:8: nep= nonEveryPattern[$pattern::afterNull] (p= pattern[$pattern::afterNull] )?
                    {
                    pushFollow(FOLLOW_nonEveryPattern_in_pattern834);
                    nep=nonEveryPattern(((pattern_scope)pattern_stack.peek()).afterNull);

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                      retval.condList =(nep!=null?nep.condList:null);((pattern_scope)pattern_stack.peek()).afterNull =(nep!=null?nep.isAfterNullOut:false);
                    }
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:289:8: (p= pattern[$pattern::afterNull] )?
                    int alt23=2;
                    switch ( input.LA(1) ) {
                        case NAME:
                        case 36:
                        case 38:
                            {
                            alt23=1;
                            }
                            break;
                    }

                    switch (alt23) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:289:10: p= pattern[$pattern::afterNull]
                            {
                            pushFollow(FOLLOW_pattern_in_pattern850);
                            p=pattern(((pattern_scope)pattern_stack.peek()).afterNull);

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                              retval.condList.addAll((p!=null?p.condList:null));((pattern_scope)pattern_stack.peek()).afterNull =(p!=null?p.isAfterNullOut:false);
                            }

                            }
                            break;

                    }


                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:290:8: ^( '!' pat= patternItem[$pattern::afterNull] ) (p= pattern[true] )
                    {
                    match(input,38,FOLLOW_38_in_pattern866); if (state.failed) return retval;

                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    pushFollow(FOLLOW_patternItem_in_pattern870);
                    pat=patternItem(((pattern_scope)pattern_stack.peek()).afterNull);

                    state._fsp--;
                    if (state.failed) return retval;

                    match(input, Token.UP, null); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                      retval.condList =new LinkedList<Condition>(); retval.condList.add(pat);
                    }
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:290:120: (p= pattern[true] )
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:290:122: p= pattern[true]
                    {
                    pushFollow(FOLLOW_pattern_in_pattern881);
                    p=pattern(true);

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                      retval.condList.addAll((p!=null?p.condList:null)); ((pattern_scope)pattern_stack.peek()).afterNull =(p!=null?p.isAfterNullOut:false);
                    }

                    }


                    }
                    break;

            }
            if ( state.backtracking==0 ) {

                         retval.isAfterNullOut =((pattern_scope)pattern_stack.peek()).afterNull;
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            pattern_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "pattern"

    public static class nonEveryPattern_return extends TreeRuleReturnScope {
        public List<Condition> condList;
        public boolean isAfterNullOut;
    };

    // $ANTLR start "nonEveryPattern"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:292:1: nonEveryPattern[boolean isAfterNull] returns [List<Condition> condList, boolean isAfterNullOut] : ( ^( '!' pat= patternItem[$isAfterNull] ) p= nonEveryPattern[true] | pat= patternItem[$isAfterNull] (p= nonEveryPattern[false] )? );
    public final SiddhiGrammarWalker.nonEveryPattern_return nonEveryPattern(boolean isAfterNull) throws RecognitionException {
        SiddhiGrammarWalker.nonEveryPattern_return retval = new SiddhiGrammarWalker.nonEveryPattern_return();
        retval.start = input.LT(1);

        Condition pat = null;

        SiddhiGrammarWalker.nonEveryPattern_return p = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:296:5: ( ^( '!' pat= patternItem[$isAfterNull] ) p= nonEveryPattern[true] | pat= patternItem[$isAfterNull] (p= nonEveryPattern[false] )? )
            int alt26=2;
            switch ( input.LA(1) ) {
            case 38:
                {
                alt26=1;
                }
                break;
            case NAME:
                {
                alt26=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }

            switch (alt26) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:296:9: ^( '!' pat= patternItem[$isAfterNull] ) p= nonEveryPattern[true]
                    {
                    match(input,38,FOLLOW_38_in_nonEveryPattern919); if (state.failed) return retval;

                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    pushFollow(FOLLOW_patternItem_in_nonEveryPattern923);
                    pat=patternItem(isAfterNull);

                    state._fsp--;
                    if (state.failed) return retval;

                    match(input, Token.UP, null); if (state.failed) return retval;
                    pushFollow(FOLLOW_nonEveryPattern_in_nonEveryPattern931);
                    p=nonEveryPattern(true);

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                      retval.condList =(p!=null?p.condList:null);Condition c=retval.condList.remove(0); retval.condList.add(0,qf.nonOccurrence(pat).followedBy(c)); isAfterNull =(p!=null?p.isAfterNullOut:false);
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:297:7: pat= patternItem[$isAfterNull] (p= nonEveryPattern[false] )?
                    {
                    pushFollow(FOLLOW_patternItem_in_nonEveryPattern944);
                    pat=patternItem(isAfterNull);

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                      retval.condList =new LinkedList<Condition>(); retval.condList.add(pat);
                    }
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:298:5: (p= nonEveryPattern[false] )?
                    int alt25=2;
                    switch ( input.LA(1) ) {
                        case 38:
                            {
                            int LA25_1 = input.LA(2);

                            if ( (synpred29_SiddhiGrammarWalker()) ) {
                                alt25=1;
                            }
                            }
                            break;
                        case NAME:
                            {
                            int LA25_2 = input.LA(2);

                            if ( (synpred29_SiddhiGrammarWalker()) ) {
                                alt25=1;
                            }
                            }
                            break;
                    }

                    switch (alt25) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:298:7: p= nonEveryPattern[false]
                            {
                            pushFollow(FOLLOW_nonEveryPattern_in_nonEveryPattern958);
                            p=nonEveryPattern(false);

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                              retval.condList.addAll((p!=null?p.condList:null));isAfterNull =(p!=null?p.isAfterNullOut:false);
                            }

                            }
                            break;

                    }


                    }
                    break;

            }
            if ( state.backtracking==0 ) {

                         retval.isAfterNullOut =isAfterNull;
                  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nonEveryPattern"


    // $ANTLR start "patternItem"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:302:1: patternItem[boolean isAfterNull] returns [ Condition cond] : ^( NAME ( withInTime )? ) ;
    public final Condition patternItem(boolean isAfterNull) throws RecognitionException {
        Condition cond = null;

        CommonTree NAME24=null;
        Integer withInTime25 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:303:2: ( ^( NAME ( withInTime )? ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:303:4: ^( NAME ( withInTime )? )
            {
            NAME24=(CommonTree)match(input,NAME,FOLLOW_NAME_in_patternItem985); if (state.failed) return cond;

            if ( state.backtracking==0 ) {
              cond = ((queryStm_scope)queryStm_stack.peek()).condDefMap.get((NAME24!=null?NAME24.getText():null));
                      ((queryStm_scope)queryStm_stack.peek()).condOrder.put("this",""+((queryStm_scope)queryStm_stack.peek()).condOrderNum);
                      if(!isAfterNull){((queryStm_scope)queryStm_stack.peek()).condOrderNum++;};
                      cond =((WhereCondition)cond).getNewInstance(((queryStm_scope)queryStm_stack.peek()).condOrder);
                      ((queryStm_scope)queryStm_stack.peek()).condOrder.put((NAME24!=null?NAME24.getText():null),""+((queryStm_scope)queryStm_stack.peek()).condOrderNum);
            }

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return cond;
                // org/siddhi/compiler/SiddhiGrammarWalker.g:308:2: ( withInTime )?
                int alt27=2;
                switch ( input.LA(1) ) {
                    case 40:
                        {
                        alt27=1;
                        }
                        break;
                }

                switch (alt27) {
                    case 1 :
                        // org/siddhi/compiler/SiddhiGrammarWalker.g:308:3: withInTime
                        {
                        pushFollow(FOLLOW_withInTime_in_patternItem991);
                        withInTime25=withInTime();

                        state._fsp--;
                        if (state.failed) return cond;
                        if ( state.backtracking==0 ) {
                           cond =((ExpirableCondition)cond).within(withInTime25);
                        }

                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return cond;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return cond;
    }
    // $ANTLR end "patternItem"


    // $ANTLR start "withInTime"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:310:1: withInTime returns [Integer value] : ^( 'within' 'time' NUM ) ;
    public final Integer withInTime() throws RecognitionException {
        Integer value = null;

        CommonTree NUM26=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:311:3: ( ^( 'within' 'time' NUM ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:311:5: ^( 'within' 'time' NUM )
            {
            match(input,40,FOLLOW_40_in_withInTime1012); if (state.failed) return value;

            match(input, Token.DOWN, null); if (state.failed) return value;
            match(input,27,FOLLOW_27_in_withInTime1015); if (state.failed) return value;
            NUM26=(CommonTree)match(input,NUM,FOLLOW_NUM_in_withInTime1018); if (state.failed) return value;

            match(input, Token.UP, null); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =Integer.parseInt((NUM26!=null?NUM26.getText():null));
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "withInTime"


    // $ANTLR start "seq"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:313:1: seq returns [List<Condition> condList] : seqItem (s= seq )? ;
    public final List<Condition> seq() throws RecognitionException {
        List<Condition> condList = null;

        List<Condition> s = null;

        Condition seqItem27 = null;



                condList =new LinkedList<Condition>();
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:317:5: ( seqItem (s= seq )? )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:317:6: seqItem (s= seq )?
            {
            pushFollow(FOLLOW_seqItem_in_seq1046);
            seqItem27=seqItem();

            state._fsp--;
            if (state.failed) return condList;
            if ( state.backtracking==0 ) {
              condList.add(seqItem27);
            }
            // org/siddhi/compiler/SiddhiGrammarWalker.g:317:46: (s= seq )?
            int alt28=2;
            switch ( input.LA(1) ) {
                case NAME:
                    {
                    alt28=1;
                    }
                    break;
            }

            switch (alt28) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:317:47: s= seq
                    {
                    pushFollow(FOLLOW_seq_in_seq1053);
                    s=seq();

                    state._fsp--;
                    if (state.failed) return condList;
                    if ( state.backtracking==0 ) {
                      condList.addAll(s);
                    }

                    }
                    break;

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return condList;
    }
    // $ANTLR end "seq"


    // $ANTLR start "seqItem"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:319:1: seqItem returns [Condition cond] : ^( NAME ( '*' )? ) ;
    public final Condition seqItem() throws RecognitionException {
        Condition cond = null;

        CommonTree NAME28=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:320:2: ( ^( NAME ( '*' )? ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:320:4: ^( NAME ( '*' )? )
            {
            NAME28=(CommonTree)match(input,NAME,FOLLOW_NAME_in_seqItem1073); if (state.failed) return cond;

            if ( state.backtracking==0 ) {

              	 ((queryStm_scope)queryStm_stack.peek()).condOrder.put((NAME28!=null?NAME28.getText():null),""+(++((queryStm_scope)queryStm_stack.peek()).condOrderNum));
              	 cond =((queryStm_scope)queryStm_stack.peek()).condDefMap.get((NAME28!=null?NAME28.getText():null));
              	 ((queryStm_scope)queryStm_stack.peek()).condOrder.put("this",""+((queryStm_scope)queryStm_stack.peek()).condOrderNum);
              	 cond =((WhereCondition)cond).getNewInstance(((queryStm_scope)queryStm_stack.peek()).condOrder);
              	   
            }

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return cond;
                // org/siddhi/compiler/SiddhiGrammarWalker.g:326:6: ( '*' )?
                int alt29=2;
                switch ( input.LA(1) ) {
                    case 20:
                        {
                        alt29=1;
                        }
                        break;
                }

                switch (alt29) {
                    case 1 :
                        // org/siddhi/compiler/SiddhiGrammarWalker.g:326:7: '*'
                        {
                        match(input,20,FOLLOW_20_in_seqItem1083); if (state.failed) return cond;
                        if ( state.backtracking==0 ) {
                          cond =new SequenceStarCondition(cond);
                        }

                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return cond;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return cond;
    }
    // $ANTLR end "seqItem"


    // $ANTLR start "cond"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:329:1: cond returns [Condition value] : ( ^( 'or' r1= cond r2= cond ) | ^( 'and' a1= cond a2= cond ) | ^( 'not' n= cond ) | ^( numOp m1= mathExpr m2= mathExpr ) | MATH );
    public final Condition cond() throws RecognitionException {
        Condition value = null;

        CommonTree MATH30=null;
        Condition r1 = null;

        Condition r2 = null;

        Condition a1 = null;

        Condition a2 = null;

        Condition n = null;

        String m1 = null;

        String m2 = null;

        ConditionOperator numOp29 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:330:5: ( ^( 'or' r1= cond r2= cond ) | ^( 'and' a1= cond a2= cond ) | ^( 'not' n= cond ) | ^( numOp m1= mathExpr m2= mathExpr ) | MATH )
            int alt30=5;
            switch ( input.LA(1) ) {
            case 41:
                {
                alt30=1;
                }
                break;
            case 42:
                {
                alt30=2;
                }
                break;
            case 49:
                {
                alt30=3;
                }
                break;
            case 67:
            case 68:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
                {
                alt30=4;
                }
                break;
            case MATH:
                {
                alt30=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 30, 0, input);

                throw nvae;
            }

            switch (alt30) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:330:6: ^( 'or' r1= cond r2= cond )
                    {
                    match(input,41,FOLLOW_41_in_cond1107); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_cond_in_cond1111);
                    r1=cond();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_cond_in_cond1115);
                    r2=cond();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =qf.or(r1,r2);
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:331:6: ^( 'and' a1= cond a2= cond )
                    {
                    match(input,42,FOLLOW_42_in_cond1128); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_cond_in_cond1132);
                    a1=cond();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_cond_in_cond1136);
                    a2=cond();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =qf.and(a1,a2);
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:332:6: ^( 'not' n= cond )
                    {
                    match(input,49,FOLLOW_49_in_cond1149); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_cond_in_cond1153);
                    n=cond();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =qf.not(n);
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:333:3: ^( numOp m1= mathExpr m2= mathExpr )
                    {
                    pushFollow(FOLLOW_numOp_in_cond1172);
                    numOp29=numOp();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_cond1176);
                    m1=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_cond1180);
                    m2=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =qf.condition(m1,numOp29,m2);
                    }

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:334:6: MATH
                    {
                    MATH30=(CommonTree)match(input,MATH,FOLLOW_MATH_in_cond1204); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =qf.condition((MATH30!=null?MATH30.getText():null).substring(0,(MATH30!=null?MATH30.getText():null).length()));
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "cond"


    // $ANTLR start "mathExpr"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:336:1: mathExpr returns [String value] : ( ^( '%' r1= mathExpr r2= mathExpr ) | ^( '/' r1= mathExpr r2= mathExpr ) | ^( '*' r1= mathExpr r2= mathExpr ) | ^( '-' r1= mathExpr r2= mathExpr ) | ^( '+' r1= mathExpr r2= mathExpr ) | vExpr );
    public final String mathExpr() throws RecognitionException {
        String value = null;

        String r1 = null;

        String r2 = null;

        String vExpr31 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:337:5: ( ^( '%' r1= mathExpr r2= mathExpr ) | ^( '/' r1= mathExpr r2= mathExpr ) | ^( '*' r1= mathExpr r2= mathExpr ) | ^( '-' r1= mathExpr r2= mathExpr ) | ^( '+' r1= mathExpr r2= mathExpr ) | vExpr )
            int alt31=6;
            switch ( input.LA(1) ) {
            case 43:
                {
                alt31=1;
                }
                break;
            case 44:
                {
                alt31=2;
                }
                break;
            case 20:
                {
                alt31=3;
                }
                break;
            case 45:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt31=4;
                    }
                    break;
                case NUM:
                    {
                    alt31=6;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return value;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 31, 4, input);

                    throw nvae;
                }

                }
                break;
            case 46:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt31=5;
                    }
                    break;
                case NUM:
                    {
                    alt31=6;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return value;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 31, 5, input);

                    throw nvae;
                }

                }
                break;
            case NAME:
            case NUM:
            case STRING:
            case 22:
            case 39:
            case 56:
            case 57:
                {
                alt31=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 31, 0, input);

                throw nvae;
            }

            switch (alt31) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:337:7: ^( '%' r1= mathExpr r2= mathExpr )
                    {
                    match(input,43,FOLLOW_43_in_mathExpr1235); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1239);
                    r1=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1243);
                    r2=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =r1+"%"+r2;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:338:7: ^( '/' r1= mathExpr r2= mathExpr )
                    {
                    match(input,44,FOLLOW_44_in_mathExpr1258); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1262);
                    r1=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1266);
                    r2=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =r1+"/"+r2;
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:339:7: ^( '*' r1= mathExpr r2= mathExpr )
                    {
                    match(input,20,FOLLOW_20_in_mathExpr1281); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1285);
                    r1=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1289);
                    r2=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =r1+"*"+r2;
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:340:7: ^( '-' r1= mathExpr r2= mathExpr )
                    {
                    match(input,45,FOLLOW_45_in_mathExpr1304); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1308);
                    r1=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1312);
                    r2=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =r1+"-"+r2;
                    }

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:341:7: ^( '+' r1= mathExpr r2= mathExpr )
                    {
                    match(input,46,FOLLOW_46_in_mathExpr1327); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1331);
                    r1=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_mathExpr1335);
                    r2=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =r1+"+"+r2;
                    }

                    }
                    break;
                case 6 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:342:6: vExpr
                    {
                    pushFollow(FOLLOW_vExpr_in_mathExpr1348);
                    vExpr31=vExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =vExpr31;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "mathExpr"


    // $ANTLR start "vExpr"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:344:1: vExpr returns [String value] : ( attriName | streamAttriName | '(' mathExpr ')' | val | condAttriName );
    public final String vExpr() throws RecognitionException {
        String value = null;

        String attriName32 = null;

        String streamAttriName33 = null;

        String mathExpr34 = null;

        String val35 = null;

        String condAttriName36 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:345:5: ( attriName | streamAttriName | '(' mathExpr ')' | val | condAttriName )
            int alt32=5;
            switch ( input.LA(1) ) {
            case NAME:
                {
                switch ( input.LA(2) ) {
                case UP:
                case NAME:
                case NUM:
                case STRING:
                case 20:
                case 22:
                case 23:
                case 39:
                case 43:
                case 44:
                case 45:
                case 46:
                case 56:
                case 57:
                    {
                    alt32=1;
                    }
                    break;
                case DOWN:
                    {
                    alt32=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return value;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 32, 1, input);

                    throw nvae;
                }

                }
                break;
            case 22:
                {
                alt32=3;
                }
                break;
            case NUM:
            case STRING:
            case 45:
            case 46:
            case 56:
            case 57:
                {
                alt32=4;
                }
                break;
            case 39:
                {
                alt32=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;
            }

            switch (alt32) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:345:6: attriName
                    {
                    pushFollow(FOLLOW_attriName_in_vExpr1374);
                    attriName32=attriName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      if( inHaving==true){value =((queryStm_scope)queryStm_stack.peek()).streamName+"."+attriName32;}else{value =((queryStm_scope)queryStm_stack.peek()).inputStreamList.get(0).getEventStream().getStreamId()+"."+attriName32; }
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:346:6: streamAttriName
                    {
                    pushFollow(FOLLOW_streamAttriName_in_vExpr1383);
                    streamAttriName33=streamAttriName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =streamAttriName33;
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:347:6: '(' mathExpr ')'
                    {
                    match(input,22,FOLLOW_22_in_vExpr1395); if (state.failed) return value;
                    pushFollow(FOLLOW_mathExpr_in_vExpr1396);
                    mathExpr34=mathExpr();

                    state._fsp--;
                    if (state.failed) return value;
                    match(input,23,FOLLOW_23_in_vExpr1397); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value ="("+mathExpr34+")";
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:348:6: val
                    {
                    pushFollow(FOLLOW_val_in_vExpr1410);
                    val35=val();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =val35;
                    }

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:349:6: condAttriName
                    {
                    pushFollow(FOLLOW_condAttriName_in_vExpr1434);
                    condAttriName36=condAttriName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =condAttriName36;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "vExpr"


    // $ANTLR start "condAttriName"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:351:2: condAttriName returns [String value] : '$' (r= condRefName ( '[' e= eventNum ']' )? | 'this' '[' 'prev' ']' ) '.' attriName ;
    public final String condAttriName() throws RecognitionException {
        String value = null;

        String r = null;

        String e = null;

        String attriName37 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:352:6: ( '$' (r= condRefName ( '[' e= eventNum ']' )? | 'this' '[' 'prev' ']' ) '.' attriName )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:352:8: '$' (r= condRefName ( '[' e= eventNum ']' )? | 'this' '[' 'prev' ']' ) '.' attriName
            {
            match(input,39,FOLLOW_39_in_condAttriName1464); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value ="$";
            }
            // org/siddhi/compiler/SiddhiGrammarWalker.g:352:26: (r= condRefName ( '[' e= eventNum ']' )? | 'this' '[' 'prev' ']' )
            int alt34=2;
            switch ( input.LA(1) ) {
            case NAME:
                {
                alt34=1;
                }
                break;
            case 47:
                {
                alt34=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 34, 0, input);

                throw nvae;
            }

            switch (alt34) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:352:27: r= condRefName ( '[' e= eventNum ']' )?
                    {
                    pushFollow(FOLLOW_condRefName_in_condAttriName1471);
                    r=condRefName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value+=r;
                    }
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:352:61: ( '[' e= eventNum ']' )?
                    int alt33=2;
                    switch ( input.LA(1) ) {
                        case 16:
                            {
                            alt33=1;
                            }
                            break;
                    }

                    switch (alt33) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:352:62: '[' e= eventNum ']'
                            {
                            match(input,16,FOLLOW_16_in_condAttriName1476); if (state.failed) return value;
                            pushFollow(FOLLOW_eventNum_in_condAttriName1481);
                            e=eventNum();

                            state._fsp--;
                            if (state.failed) return value;
                            match(input,17,FOLLOW_17_in_condAttriName1483); if (state.failed) return value;
                            if ( state.backtracking==0 ) {
                              value+='.'+e;
                            }

                            }
                            break;

                    }


                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:352:109: 'this' '[' 'prev' ']'
                    {
                    match(input,47,FOLLOW_47_in_condAttriName1490); if (state.failed) return value;
                    match(input,16,FOLLOW_16_in_condAttriName1492); if (state.failed) return value;
                    match(input,48,FOLLOW_48_in_condAttriName1494); if (state.failed) return value;
                    match(input,17,FOLLOW_17_in_condAttriName1496); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value+="this.prev";
                    }

                    }
                    break;

            }

            match(input,26,FOLLOW_26_in_condAttriName1507); if (state.failed) return value;
            pushFollow(FOLLOW_attriName_in_condAttriName1509);
            attriName37=attriName();

            state._fsp--;
            if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value+="."+attriName37;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "condAttriName"


    // $ANTLR start "stmName"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:355:1: stmName returns [String value] : NAME ;
    public final String stmName() throws RecognitionException {
        String value = null;

        CommonTree NAME38=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:356:5: ( NAME )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:356:6: NAME
            {
            NAME38=(CommonTree)match(input,NAME,FOLLOW_NAME_in_stmName1533); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =(NAME38!=null?NAME38.getText():null);
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "stmName"


    // $ANTLR start "streamAttriName"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:358:1: streamAttriName returns [String value] : ^( stmName attriName ) ;
    public final String streamAttriName() throws RecognitionException {
        String value = null;

        String stmName39 = null;

        String attriName40 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:359:2: ( ^( stmName attriName ) )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:359:3: ^( stmName attriName )
            {
            pushFollow(FOLLOW_stmName_in_streamAttriName1575);
            stmName39=stmName();

            state._fsp--;
            if (state.failed) return value;

            match(input, Token.DOWN, null); if (state.failed) return value;
            pushFollow(FOLLOW_attriName_in_streamAttriName1578);
            attriName40=attriName();

            state._fsp--;
            if (state.failed) return value;

            match(input, Token.UP, null); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =stmName39 +"."+attriName40;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "streamAttriName"


    // $ANTLR start "attriName"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:361:1: attriName returns [String value] : NAME ;
    public final String attriName() throws RecognitionException {
        String value = null;

        CommonTree NAME41=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:362:5: ( NAME )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:362:6: NAME
            {
            NAME41=(CommonTree)match(input,NAME,FOLLOW_NAME_in_attriName1606); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =(NAME41!=null?NAME41.getText():null);
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "attriName"


    // $ANTLR start "outAttriName"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:364:1: outAttriName returns [String value] : ( attriName | streamAttriName | ^( '$' ^( condRefName ( eventNum )? NAME ) ) );
    public final String outAttriName() throws RecognitionException {
        String value = null;

        CommonTree NAME46=null;
        String attriName42 = null;

        String streamAttriName43 = null;

        String eventNum44 = null;

        String condRefName45 = null;



                value ="";
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:368:2: ( attriName | streamAttriName | ^( '$' ^( condRefName ( eventNum )? NAME ) ) )
            int alt36=3;
            switch ( input.LA(1) ) {
            case NAME:
                {
                switch ( input.LA(2) ) {
                case EOF:
                case UP:
                case NAME:
                case 23:
                case 39:
                    {
                    alt36=1;
                    }
                    break;
                case DOWN:
                    {
                    alt36=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return value;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 36, 1, input);

                    throw nvae;
                }

                }
                break;
            case 39:
                {
                alt36=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }

            switch (alt36) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:368:4: attriName
                    {
                    pushFollow(FOLLOW_attriName_in_outAttriName1657);
                    attriName42=attriName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =attriName42; 
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:369:4: streamAttriName
                    {
                    pushFollow(FOLLOW_streamAttriName_in_outAttriName1684);
                    streamAttriName43=streamAttriName();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =streamAttriName43; 
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:370:3: ^( '$' ^( condRefName ( eventNum )? NAME ) )
                    {
                    match(input,39,FOLLOW_39_in_outAttriName1705); if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    pushFollow(FOLLOW_condRefName_in_outAttriName1708);
                    condRefName45=condRefName();

                    state._fsp--;
                    if (state.failed) return value;

                    match(input, Token.DOWN, null); if (state.failed) return value;
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:370:23: ( eventNum )?
                    int alt35=2;
                    switch ( input.LA(1) ) {
                        case NUM:
                        case 50:
                            {
                            alt35=1;
                            }
                            break;
                    }

                    switch (alt35) {
                        case 1 :
                            // org/siddhi/compiler/SiddhiGrammarWalker.g:370:24: eventNum
                            {
                            pushFollow(FOLLOW_eventNum_in_outAttriName1711);
                            eventNum44=eventNum();

                            state._fsp--;
                            if (state.failed) return value;
                            if ( state.backtracking==0 ) {
                              value+="."+eventNum44;
                            }

                            }
                            break;

                    }

                    NAME46=(CommonTree)match(input,NAME,FOLLOW_NAME_in_outAttriName1718); if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;

                    match(input, Token.UP, null); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value = "$"+((queryStm_scope)queryStm_stack.peek()).condOrder.get(condRefName45)+ value+"."+(NAME46!=null?NAME46.getText():null);	
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "outAttriName"


    // $ANTLR start "condRefName"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:373:1: condRefName returns [String value] : NAME ;
    public final String condRefName() throws RecognitionException {
        String value = null;

        CommonTree NAME47=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:374:2: ( NAME )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:374:3: NAME
            {
            NAME47=(CommonTree)match(input,NAME,FOLLOW_NAME_in_condRefName1736); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =(NAME47!=null?NAME47.getText():null);
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "condRefName"


    // $ANTLR start "eventNum"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:376:1: eventNum returns [String value] : ( NUM | 'last' );
    public final String eventNum() throws RecognitionException {
        String value = null;

        CommonTree NUM48=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:377:2: ( NUM | 'last' )
            int alt37=2;
            switch ( input.LA(1) ) {
            case NUM:
                {
                alt37=1;
                }
                break;
            case 50:
                {
                alt37=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 37, 0, input);

                throw nvae;
            }

            switch (alt37) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:377:3: NUM
                    {
                    NUM48=(CommonTree)match(input,NUM,FOLLOW_NUM_in_eventNum1755); if (state.failed) return value;
                    if ( state.backtracking==0 ) {

                      	    if((NUM48!=null?NUM48.getText():null).equals("0")){
                      	        value ="start";
                      	    }else{
                      	        throw new SiddhiCompilationException("Siddhi not yet support ["+(NUM48!=null?NUM48.getText():null)+"] only [0] and [last] is supported for now");
                      	    }
                      	
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:385:3: 'last'
                    {
                    match(input,50,FOLLOW_50_in_eventNum1762); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value ="last";
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "eventNum"


    // $ANTLR start "aggregate"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:387:1: aggregate returns [String value] : (a= 'avg' | a= 'sum' | a= 'max' | a= 'min' | a= 'count' ) '(' outAttriName ')' ;
    public final String aggregate() throws RecognitionException {
        String value = null;

        CommonTree a=null;
        String outAttriName49 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:388:5: ( (a= 'avg' | a= 'sum' | a= 'max' | a= 'min' | a= 'count' ) '(' outAttriName ')' )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:388:6: (a= 'avg' | a= 'sum' | a= 'max' | a= 'min' | a= 'count' ) '(' outAttriName ')'
            {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:388:6: (a= 'avg' | a= 'sum' | a= 'max' | a= 'min' | a= 'count' )
            int alt38=5;
            switch ( input.LA(1) ) {
            case 51:
                {
                alt38=1;
                }
                break;
            case 52:
                {
                alt38=2;
                }
                break;
            case 53:
                {
                alt38=3;
                }
                break;
            case 54:
                {
                alt38=4;
                }
                break;
            case 55:
                {
                alt38=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 38, 0, input);

                throw nvae;
            }

            switch (alt38) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:388:7: a= 'avg'
                    {
                    a=(CommonTree)match(input,51,FOLLOW_51_in_aggregate1787); if (state.failed) return value;

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:388:15: a= 'sum'
                    {
                    a=(CommonTree)match(input,52,FOLLOW_52_in_aggregate1791); if (state.failed) return value;

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:388:23: a= 'max'
                    {
                    a=(CommonTree)match(input,53,FOLLOW_53_in_aggregate1795); if (state.failed) return value;

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:388:31: a= 'min'
                    {
                    a=(CommonTree)match(input,54,FOLLOW_54_in_aggregate1799); if (state.failed) return value;

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:388:39: a= 'count'
                    {
                    a=(CommonTree)match(input,55,FOLLOW_55_in_aggregate1803); if (state.failed) return value;

                    }
                    break;

            }

            match(input,22,FOLLOW_22_in_aggregate1807); if (state.failed) return value;
            pushFollow(FOLLOW_outAttriName_in_aggregate1809);
            outAttriName49=outAttriName();

            state._fsp--;
            if (state.failed) return value;
            match(input,23,FOLLOW_23_in_aggregate1811); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =(a!=null?a.getText():null)+"("+outAttriName49+")";
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "aggregate"


    // $ANTLR start "val"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:391:1: val returns [String value] : ( unsignNum | '+' unsignNum | '-' unsignNum | t= 'true' | f= 'false' | string );
    public final String val() throws RecognitionException {
        String value = null;

        CommonTree t=null;
        CommonTree f=null;
        String unsignNum50 = null;

        String unsignNum51 = null;

        String unsignNum52 = null;

        String string53 = null;


        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:392:5: ( unsignNum | '+' unsignNum | '-' unsignNum | t= 'true' | f= 'false' | string )
            int alt39=6;
            switch ( input.LA(1) ) {
            case NUM:
                {
                alt39=1;
                }
                break;
            case 46:
                {
                alt39=2;
                }
                break;
            case 45:
                {
                alt39=3;
                }
                break;
            case 56:
                {
                alt39=4;
                }
                break;
            case 57:
                {
                alt39=5;
                }
                break;
            case STRING:
                {
                alt39=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 39, 0, input);

                throw nvae;
            }

            switch (alt39) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:392:6: unsignNum
                    {
                    pushFollow(FOLLOW_unsignNum_in_val1833);
                    unsignNum50=unsignNum();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =unsignNum50;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:393:6: '+' unsignNum
                    {
                    match(input,46,FOLLOW_46_in_val1851); if (state.failed) return value;
                    pushFollow(FOLLOW_unsignNum_in_val1853);
                    unsignNum51=unsignNum();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =unsignNum51;
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:394:7: '-' unsignNum
                    {
                    match(input,45,FOLLOW_45_in_val1868); if (state.failed) return value;
                    pushFollow(FOLLOW_unsignNum_in_val1870);
                    unsignNum52=unsignNum();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value ="-"+unsignNum52;
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:395:6: t= 'true'
                    {
                    t=(CommonTree)match(input,56,FOLLOW_56_in_val1884); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =(t!=null?t.getText():null);
                    }

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:396:6: f= 'false'
                    {
                    f=(CommonTree)match(input,57,FOLLOW_57_in_val1906); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =(f!=null?f.getText():null);
                    }

                    }
                    break;
                case 6 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:397:6: string
                    {
                    pushFollow(FOLLOW_string_in_val1925);
                    string53=string();

                    state._fsp--;
                    if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =string53;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "val"


    // $ANTLR start "unsignNum"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:399:1: unsignNum returns [String value] : ( NUM | a= NUM '.' b= NUM );
    public final String unsignNum() throws RecognitionException {
        String value = null;

        CommonTree a=null;
        CommonTree b=null;
        CommonTree NUM54=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:400:5: ( NUM | a= NUM '.' b= NUM )
            int alt40=2;
            switch ( input.LA(1) ) {
            case NUM:
                {
                switch ( input.LA(2) ) {
                case 26:
                    {
                    alt40=2;
                    }
                    break;
                case EOF:
                case UP:
                case NAME:
                case NUM:
                case STRING:
                case 20:
                case 22:
                case 23:
                case 39:
                case 43:
                case 44:
                case 45:
                case 46:
                case 56:
                case 57:
                    {
                    alt40=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return value;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 40, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return value;}
                NoViableAltException nvae =
                    new NoViableAltException("", 40, 0, input);

                throw nvae;
            }

            switch (alt40) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:400:6: NUM
                    {
                    NUM54=(CommonTree)match(input,NUM,FOLLOW_NUM_in_unsignNum1954); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =(NUM54!=null?NUM54.getText():null);
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:401:6: a= NUM '.' b= NUM
                    {
                    a=(CommonTree)match(input,NUM,FOLLOW_NUM_in_unsignNum1980); if (state.failed) return value;
                    match(input,26,FOLLOW_26_in_unsignNum1982); if (state.failed) return value;
                    b=(CommonTree)match(input,NUM,FOLLOW_NUM_in_unsignNum1986); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value =(a!=null?a.getText():null)+"."+(b!=null?b.getText():null);
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "unsignNum"


    // $ANTLR start "num"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:403:1: num returns [String value] : (p= '+' | m= '-' )? unsignNum ;
    public final String num() throws RecognitionException {
        String value = null;

        CommonTree p=null;
        CommonTree m=null;
        String unsignNum55 = null;



                value ="";
            
        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:407:5: ( (p= '+' | m= '-' )? unsignNum )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:407:7: (p= '+' | m= '-' )? unsignNum
            {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:407:7: (p= '+' | m= '-' )?
            int alt41=3;
            switch ( input.LA(1) ) {
                case 46:
                    {
                    alt41=1;
                    }
                    break;
                case 45:
                    {
                    alt41=2;
                    }
                    break;
            }

            switch (alt41) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:407:9: p= '+'
                    {
                    p=(CommonTree)match(input,46,FOLLOW_46_in_num2020); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value+=(p!=null?p.getText():null);
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:408:10: m= '-'
                    {
                    m=(CommonTree)match(input,45,FOLLOW_45_in_num2039); if (state.failed) return value;
                    if ( state.backtracking==0 ) {
                      value+=(m!=null?m.getText():null);
                    }

                    }
                    break;

            }

            pushFollow(FOLLOW_unsignNum_in_num2061);
            unsignNum55=unsignNum();

            state._fsp--;
            if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =unsignNum55;
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "num"


    // $ANTLR start "type"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:412:1: type returns [Class classType] : ( 'string' | 'int' | 'long' | 'float' | 'double' | 'bool' | 'date' );
    public final Class type() throws RecognitionException {
        Class classType = null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:413:5: ( 'string' | 'int' | 'long' | 'float' | 'double' | 'bool' | 'date' )
            int alt42=7;
            switch ( input.LA(1) ) {
            case 58:
                {
                alt42=1;
                }
                break;
            case 59:
                {
                alt42=2;
                }
                break;
            case 60:
                {
                alt42=3;
                }
                break;
            case 61:
                {
                alt42=4;
                }
                break;
            case 62:
                {
                alt42=5;
                }
                break;
            case 63:
                {
                alt42=6;
                }
                break;
            case 64:
                {
                alt42=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return classType;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }

            switch (alt42) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:413:6: 'string'
                    {
                    match(input,58,FOLLOW_58_in_type2079); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =String.class;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:414:6: 'int'
                    {
                    match(input,59,FOLLOW_59_in_type2088); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =Integer.class;
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:415:6: 'long'
                    {
                    match(input,60,FOLLOW_60_in_type2097); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =Long.class;
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:416:6: 'float'
                    {
                    match(input,61,FOLLOW_61_in_type2106); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =Float.class;
                    }

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:417:6: 'double'
                    {
                    match(input,62,FOLLOW_62_in_type2115); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =Double.class;
                    }

                    }
                    break;
                case 6 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:418:6: 'bool'
                    {
                    match(input,63,FOLLOW_63_in_type2124); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =Boolean.class;
                    }

                    }
                    break;
                case 7 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:419:6: 'date'
                    {
                    match(input,64,FOLLOW_64_in_type2133); if (state.failed) return classType;
                    if ( state.backtracking==0 ) {
                      classType =Date.class;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return classType;
    }
    // $ANTLR end "type"


    // $ANTLR start "winType"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:421:1: winType returns [WindowType type] : ( 'time' | 'time' '.' 'batch' | 'length' | 'length' '.' 'batch' );
    public final WindowType winType() throws RecognitionException {
        WindowType type = null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:422:5: ( 'time' | 'time' '.' 'batch' | 'length' | 'length' '.' 'batch' )
            int alt43=4;
            switch ( input.LA(1) ) {
            case 27:
                {
                switch ( input.LA(2) ) {
                case 26:
                    {
                    alt43=2;
                    }
                    break;
                case NUM:
                    {
                    alt43=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return type;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 43, 1, input);

                    throw nvae;
                }

                }
                break;
            case 29:
                {
                switch ( input.LA(2) ) {
                case 26:
                    {
                    alt43=4;
                    }
                    break;
                case NUM:
                    {
                    alt43=3;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return type;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 43, 2, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return type;}
                NoViableAltException nvae =
                    new NoViableAltException("", 43, 0, input);

                throw nvae;
            }

            switch (alt43) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:422:6: 'time'
                    {
                    match(input,27,FOLLOW_27_in_winType2151); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type =WindowType.TIME;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:423:6: 'time' '.' 'batch'
                    {
                    match(input,27,FOLLOW_27_in_winType2176); if (state.failed) return type;
                    match(input,26,FOLLOW_26_in_winType2178); if (state.failed) return type;
                    match(input,28,FOLLOW_28_in_winType2180); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type =WindowType.TIME_BATCH;
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:424:6: 'length'
                    {
                    match(input,29,FOLLOW_29_in_winType2193); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type =WindowType.LENGTH;
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:425:6: 'length' '.' 'batch'
                    {
                    match(input,29,FOLLOW_29_in_winType2216); if (state.failed) return type;
                    match(input,26,FOLLOW_26_in_winType2218); if (state.failed) return type;
                    match(input,28,FOLLOW_28_in_winType2220); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type =WindowType.LENGTH_BATCH;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return type;
    }
    // $ANTLR end "winType"


    // $ANTLR start "uniqueType"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:427:1: uniqueType returns [StandardView type] : ( 'firstUnique' | 'unique' );
    public final StandardView uniqueType() throws RecognitionException {
        StandardView type = null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:428:5: ( 'firstUnique' | 'unique' )
            int alt44=2;
            switch ( input.LA(1) ) {
            case 65:
                {
                alt44=1;
                }
                break;
            case 66:
                {
                alt44=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return type;}
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;
            }

            switch (alt44) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:428:6: 'firstUnique'
                    {
                    match(input,65,FOLLOW_65_in_uniqueType2240); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type = StandardView.FIRST_UNIQUE;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:429:6: 'unique'
                    {
                    match(input,66,FOLLOW_66_in_uniqueType2250); if (state.failed) return type;
                    if ( state.backtracking==0 ) {
                      type = StandardView.UNIQUE;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return type;
    }
    // $ANTLR end "uniqueType"


    // $ANTLR start "numOp"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:431:1: numOp returns [ConditionOperator op] : ( '==' | '!=' | '<' | '>' | '<=' | '>=' | 'contains' );
    public final ConditionOperator numOp() throws RecognitionException {
        ConditionOperator op = null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:432:5: ( '==' | '!=' | '<' | '>' | '<=' | '>=' | 'contains' )
            int alt45=7;
            switch ( input.LA(1) ) {
            case 67:
                {
                alt45=1;
                }
                break;
            case 68:
                {
                alt45=2;
                }
                break;
            case 69:
                {
                alt45=3;
                }
                break;
            case 70:
                {
                alt45=4;
                }
                break;
            case 71:
                {
                alt45=5;
                }
                break;
            case 72:
                {
                alt45=6;
                }
                break;
            case 73:
                {
                alt45=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return op;}
                NoViableAltException nvae =
                    new NoViableAltException("", 45, 0, input);

                throw nvae;
            }

            switch (alt45) {
                case 1 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:432:6: '=='
                    {
                    match(input,67,FOLLOW_67_in_numOp2277); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.EQUAL;
                    }

                    }
                    break;
                case 2 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:433:6: '!='
                    {
                    match(input,68,FOLLOW_68_in_numOp2293); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.NOT_EQUAL;
                    }

                    }
                    break;
                case 3 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:434:6: '<'
                    {
                    match(input,69,FOLLOW_69_in_numOp2309); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.LESSTHAN;
                    }

                    }
                    break;
                case 4 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:435:6: '>'
                    {
                    match(input,70,FOLLOW_70_in_numOp2326); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.GREATERTHAN;
                    }

                    }
                    break;
                case 5 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:436:6: '<='
                    {
                    match(input,71,FOLLOW_71_in_numOp2343); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.LESSTHAN_EQUAL;
                    }

                    }
                    break;
                case 6 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:437:6: '>='
                    {
                    match(input,72,FOLLOW_72_in_numOp2359); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.GREATERTHAN_EQUAL;
                    }

                    }
                    break;
                case 7 :
                    // org/siddhi/compiler/SiddhiGrammarWalker.g:438:6: 'contains'
                    {
                    match(input,73,FOLLOW_73_in_numOp2375); if (state.failed) return op;
                    if ( state.backtracking==0 ) {
                      op = ConditionOperator.CONTAINS;
                    }

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return op;
    }
    // $ANTLR end "numOp"


    // $ANTLR start "string"
    // org/siddhi/compiler/SiddhiGrammarWalker.g:440:1: string returns [String value] : STRING ;
    public final String string() throws RecognitionException {
        String value = null;

        CommonTree STRING56=null;

        try {
            // org/siddhi/compiler/SiddhiGrammarWalker.g:441:5: ( STRING )
            // org/siddhi/compiler/SiddhiGrammarWalker.g:441:6: STRING
            {
            STRING56=(CommonTree)match(input,STRING,FOLLOW_STRING_in_string2394); if (state.failed) return value;
            if ( state.backtracking==0 ) {
              value =(STRING56!=null?STRING56.getText():null).substring(1,(STRING56!=null?STRING56.getText():null).length()-1);
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "string"

    // $ANTLR start synpred10_SiddhiGrammarWalker
    public final void synpred10_SiddhiGrammarWalker_fragment() throws RecognitionException {   
        // org/siddhi/compiler/SiddhiGrammarWalker.g:181:6: ( ^( NAME ( aggregate | defaultOut | outAttriName ) ) )
        // org/siddhi/compiler/SiddhiGrammarWalker.g:181:6: ^( NAME ( aggregate | defaultOut | outAttriName ) )
        {
        match(input,NAME,FOLLOW_NAME_in_synpred10_SiddhiGrammarWalker290); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        // org/siddhi/compiler/SiddhiGrammarWalker.g:182:9: ( aggregate | defaultOut | outAttriName )
        int alt46=3;
        switch ( input.LA(1) ) {
        case 51:
        case 52:
        case 53:
        case 54:
        case 55:
            {
            alt46=1;
            }
            break;
        case DEFAULT_OUTPUT:
            {
            alt46=2;
            }
            break;
        case NAME:
        case 39:
            {
            alt46=3;
            }
            break;
        default:
            if (state.backtracking>0) {state.failed=true; return ;}
            NoViableAltException nvae =
                new NoViableAltException("", 46, 0, input);

            throw nvae;
        }

        switch (alt46) {
            case 1 :
                // org/siddhi/compiler/SiddhiGrammarWalker.g:183:9: aggregate
                {
                pushFollow(FOLLOW_aggregate_in_synpred10_SiddhiGrammarWalker313);
                aggregate();

                state._fsp--;
                if (state.failed) return ;

                }
                break;
            case 2 :
                // org/siddhi/compiler/SiddhiGrammarWalker.g:184:10: defaultOut
                {
                pushFollow(FOLLOW_defaultOut_in_synpred10_SiddhiGrammarWalker326);
                defaultOut();

                state._fsp--;
                if (state.failed) return ;

                }
                break;
            case 3 :
                // org/siddhi/compiler/SiddhiGrammarWalker.g:185:10: outAttriName
                {
                pushFollow(FOLLOW_outAttriName_in_synpred10_SiddhiGrammarWalker339);
                outAttriName();

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }


        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred10_SiddhiGrammarWalker

    // $ANTLR start synpred27_SiddhiGrammarWalker
    public final void synpred27_SiddhiGrammarWalker_fragment() throws RecognitionException {   
        SiddhiGrammarWalker.nonEveryPattern_return nep = null;

        SiddhiGrammarWalker.pattern_return p = null;


        // org/siddhi/compiler/SiddhiGrammarWalker.g:288:8: (nep= nonEveryPattern[$pattern::afterNull] (p= pattern[$pattern::afterNull] )? )
        // org/siddhi/compiler/SiddhiGrammarWalker.g:288:8: nep= nonEveryPattern[$pattern::afterNull] (p= pattern[$pattern::afterNull] )?
        {
        pushFollow(FOLLOW_nonEveryPattern_in_synpred27_SiddhiGrammarWalker834);
        nep=nonEveryPattern(((pattern_scope)pattern_stack.peek()).afterNull);

        state._fsp--;
        if (state.failed) return ;
        // org/siddhi/compiler/SiddhiGrammarWalker.g:289:8: (p= pattern[$pattern::afterNull] )?
        int alt52=2;
        switch ( input.LA(1) ) {
            case NAME:
            case 36:
            case 38:
                {
                alt52=1;
                }
                break;
        }

        switch (alt52) {
            case 1 :
                // org/siddhi/compiler/SiddhiGrammarWalker.g:289:10: p= pattern[$pattern::afterNull]
                {
                pushFollow(FOLLOW_pattern_in_synpred27_SiddhiGrammarWalker850);
                p=pattern(((pattern_scope)pattern_stack.peek()).afterNull);

                state._fsp--;
                if (state.failed) return ;

                }
                break;

        }


        }
    }
    // $ANTLR end synpred27_SiddhiGrammarWalker

    // $ANTLR start synpred29_SiddhiGrammarWalker
    public final void synpred29_SiddhiGrammarWalker_fragment() throws RecognitionException {   
        SiddhiGrammarWalker.nonEveryPattern_return p = null;


        // org/siddhi/compiler/SiddhiGrammarWalker.g:298:7: (p= nonEveryPattern[false] )
        // org/siddhi/compiler/SiddhiGrammarWalker.g:298:7: p= nonEveryPattern[false]
        {
        pushFollow(FOLLOW_nonEveryPattern_in_synpred29_SiddhiGrammarWalker958);
        p=nonEveryPattern(false);

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred29_SiddhiGrammarWalker

    // Delegated rules

    public final boolean synpred29_SiddhiGrammarWalker() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred29_SiddhiGrammarWalker_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred27_SiddhiGrammarWalker() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred27_SiddhiGrammarWalker_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred10_SiddhiGrammarWalker() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred10_SiddhiGrammarWalker_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


 

    public static final BitSet FOLLOW_stream_in_siddhiGrammar80 = new BitSet(new long[]{0x0000000000000202L});
    public static final BitSet FOLLOW_stmName_in_stream105 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_streamType_in_stream109 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_inputStm_in_streamType124 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_queryStm_in_streamType130 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_inputStm165 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_type_in_inputStm169 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_queryInput_in_queryStm217 = new BitSet(new long[]{0x0000000180080102L});
    public static final BitSet FOLLOW_queryCond_in_queryStm219 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_queryOutput_in_queryStm222 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_19_in_queryOutput252 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_20_in_queryOutput254 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_19_in_queryOutput263 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_outputItem_in_queryOutput267 = new BitSet(new long[]{0x000000800000020CL});
    public static final BitSet FOLLOW_NAME_in_outputItem290 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_aggregate_in_outputItem313 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_defaultOut_in_outputItem326 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_outAttriName_in_outputItem339 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_outAttriName_in_outputItem361 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DEFAULT_OUTPUT_in_defaultOut383 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_type_in_defaultOut386 = new BitSet(new long[]{0x0300600000000C00L});
    public static final BitSet FOLLOW_val_in_defaultOut388 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_24_in_queryInput408 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_queryInputStm_in_queryInput410 = new BitSet(new long[]{0x000000000000022CL});
    public static final BitSet FOLLOW_NEW_STREAM_in_queryInputStm439 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_queryStm_in_queryInputStm442 = new BitSet(new long[]{0x0000000000000048L});
    public static final BitSet FOLLOW_stmProp_in_queryInputStm458 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_stmName_in_queryInputStm467 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stmProp_in_queryInputStm484 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_STREAM_PROP_in_stmProp497 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stmStd_in_stmProp499 = new BitSet(new long[]{0x0000000002000008L});
    public static final BitSet FOLLOW_stmWin_in_stmProp502 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_25_in_stmWin518 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_winType_in_stmWin520 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_NUM_in_stmWin522 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_30_in_stmStd541 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uniqueType_in_stmStd543 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_attriName_in_stmStd545 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COND_in_queryCond562 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_whareCond_in_queryCond564 = new BitSet(new long[]{0x0000000C00000008L});
    public static final BitSet FOLLOW_gpByCond_in_queryCond567 = new BitSet(new long[]{0x0000000400000008L});
    public static final BitSet FOLLOW_havingCond_in_queryCond571 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_31_in_queryCond579 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COND_DEF_in_queryCond583 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condDefs_in_queryCond585 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COND_in_queryCond590 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_pattern_in_queryCond592 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_32_in_queryCond604 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COND_DEF_in_queryCond607 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condDefs_in_queryCond609 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COND_in_queryCond613 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_seq_in_queryCond615 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_33_in_whareCond629 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_whareCond631 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_34_in_havingCond663 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_havingCond665 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_35_in_gpByCond679 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_attriName_in_gpByCond681 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_35_in_gpByCond696 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_streamAttriName_in_gpByCond698 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_condDef_in_condDefs712 = new BitSet(new long[]{0x0000000000000202L});
    public static final BitSet FOLLOW_NAME_in_condDef726 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_condDef728 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_36_in_pattern796 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_nonEveryPattern_in_pattern800 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_pattern_in_pattern817 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nonEveryPattern_in_pattern834 = new BitSet(new long[]{0x0000005000000202L});
    public static final BitSet FOLLOW_pattern_in_pattern850 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_38_in_pattern866 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_patternItem_in_pattern870 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_pattern_in_pattern881 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_38_in_nonEveryPattern919 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_patternItem_in_nonEveryPattern923 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_nonEveryPattern_in_nonEveryPattern931 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_patternItem_in_nonEveryPattern944 = new BitSet(new long[]{0x0000004000000202L});
    public static final BitSet FOLLOW_nonEveryPattern_in_nonEveryPattern958 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_patternItem985 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_withInTime_in_patternItem991 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_40_in_withInTime1012 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_27_in_withInTime1015 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_NUM_in_withInTime1018 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_seqItem_in_seq1046 = new BitSet(new long[]{0x0000000000000202L});
    public static final BitSet FOLLOW_seq_in_seq1053 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_seqItem1073 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_20_in_seqItem1083 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_41_in_cond1107 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_cond1111 = new BitSet(new long[]{0x0002060000000000L,0x00000000000007F8L});
    public static final BitSet FOLLOW_cond_in_cond1115 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_42_in_cond1128 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_cond1132 = new BitSet(new long[]{0x0002060000000000L,0x00000000000007F8L});
    public static final BitSet FOLLOW_cond_in_cond1136 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_49_in_cond1149 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_cond_in_cond1153 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_numOp_in_cond1172 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_mathExpr_in_cond1176 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_cond1180 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MATH_in_cond1204 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_43_in_mathExpr1235 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1239 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1243 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_44_in_mathExpr1258 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1262 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1266 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_20_in_mathExpr1281 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1285 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1289 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_45_in_mathExpr1304 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1308 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1312 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_46_in_mathExpr1327 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1331 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_mathExpr1335 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_vExpr_in_mathExpr1348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attriName_in_vExpr1374 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_streamAttriName_in_vExpr1383 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_vExpr1395 = new BitSet(new long[]{0x0300788000500E04L});
    public static final BitSet FOLLOW_mathExpr_in_vExpr1396 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_vExpr1397 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_val_in_vExpr1410 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_condAttriName_in_vExpr1434 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_39_in_condAttriName1464 = new BitSet(new long[]{0x0000800000000200L});
    public static final BitSet FOLLOW_condRefName_in_condAttriName1471 = new BitSet(new long[]{0x0000000004010000L});
    public static final BitSet FOLLOW_16_in_condAttriName1476 = new BitSet(new long[]{0x0004000000000400L});
    public static final BitSet FOLLOW_eventNum_in_condAttriName1481 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_condAttriName1483 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_47_in_condAttriName1490 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_condAttriName1492 = new BitSet(new long[]{0x0001000000000000L});
    public static final BitSet FOLLOW_48_in_condAttriName1494 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_condAttriName1496 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_26_in_condAttriName1507 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_attriName_in_condAttriName1509 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_stmName1533 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stmName_in_streamAttriName1575 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_attriName_in_streamAttriName1578 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_NAME_in_attriName1606 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attriName_in_outAttriName1657 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_streamAttriName_in_outAttriName1684 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_39_in_outAttriName1705 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_condRefName_in_outAttriName1708 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_eventNum_in_outAttriName1711 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_NAME_in_outAttriName1718 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_NAME_in_condRefName1736 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUM_in_eventNum1755 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_50_in_eventNum1762 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_51_in_aggregate1787 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_52_in_aggregate1791 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_53_in_aggregate1795 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_54_in_aggregate1799 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_55_in_aggregate1803 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22_in_aggregate1807 = new BitSet(new long[]{0x000000800000020CL});
    public static final BitSet FOLLOW_outAttriName_in_aggregate1809 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_aggregate1811 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unsignNum_in_val1833 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_46_in_val1851 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_unsignNum_in_val1853 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_45_in_val1868 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_unsignNum_in_val1870 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_56_in_val1884 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_57_in_val1906 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_val1925 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUM_in_unsignNum1954 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NUM_in_unsignNum1980 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_26_in_unsignNum1982 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_NUM_in_unsignNum1986 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_46_in_num2020 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_45_in_num2039 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_unsignNum_in_num2061 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_58_in_type2079 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_59_in_type2088 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_60_in_type2097 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_61_in_type2106 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_62_in_type2115 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_63_in_type2124 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_64_in_type2133 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_27_in_winType2151 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_27_in_winType2176 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_26_in_winType2178 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_winType2180 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_29_in_winType2193 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_29_in_winType2216 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_26_in_winType2218 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_winType2220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_65_in_uniqueType2240 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_66_in_uniqueType2250 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_67_in_numOp2277 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_68_in_numOp2293 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_69_in_numOp2309 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_70_in_numOp2326 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_71_in_numOp2343 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_72_in_numOp2359 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_73_in_numOp2375 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STRING_in_string2394 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_synpred10_SiddhiGrammarWalker290 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_aggregate_in_synpred10_SiddhiGrammarWalker313 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_defaultOut_in_synpred10_SiddhiGrammarWalker326 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_outAttriName_in_synpred10_SiddhiGrammarWalker339 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_nonEveryPattern_in_synpred27_SiddhiGrammarWalker834 = new BitSet(new long[]{0x0000005000000202L});
    public static final BitSet FOLLOW_pattern_in_synpred27_SiddhiGrammarWalker850 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nonEveryPattern_in_synpred29_SiddhiGrammarWalker958 = new BitSet(new long[]{0x0000000000000002L});

}